/* Copyright (c) 2001 by the Institute for Computer Science,               */
/* Alberts-Ludwigs-University of Freiburg, Germany.                        */
/* All Rights Reserved.  This software is for educational purposes only.   */
/* Permission is given to distribute this code provided that this intro-   */
/* ductory message is not removed and no monies are exchanged.             */
/* No guarantee is expressed or implied by the distribution of this code.  */
/* Software written by Alberto Lluch Lafuente and Stefan Edelkamp.         */
/* References:                                                             */
/* - Stefan Edelkamp, Alberto Lluch Lafuente and Stefan Leue,              */
/*   Directed Explicit Model Checking with HSF-SPIN, to appear in:         */
/*   Proc. 8th International SPIN Workshop on Model Checking Software,     */
/*   Springer LNCS 2057, Toronto, May 2001                                 */
/* - Stefan Edelkamp, Alberto Lluch Lafuente and Stefan Leue,              */
/*   Protocol Verification with Heuristic Search,                          */
/*   Proc. AAAI Spring Symposium on Model-Based Validation of Inteligence, */
/*   AAAI, Stanford, April 2001.                                           */
/* Send bug-reports or questions to: lafuente@informatik.uni-freiburg.de   */

#ifndef _COMPRESSION_H_
#define _COMPRESSION_H_

/* State compression alternatives */
int Selected_Compression;
#define NO_COMPRESSION 0
#define BYTE_MASKING_COMPRESSION 1
#define DMA_COMPRESSION  2          /* Not implemented yet. */
#define COLLAPSE_COMPRESSION 3       /* Not implemented yet. */
#define TEST_COMPRESSION 4
#define DEFAULT_COMPRESSION NO_COMPRESSION

void print_compressions();
void init_compression();
void init_byte_masking();

#endif //
